package com.example.refactor.entity.v2;

import javax.persistence.*;
import java.util.Date;

/**
 * 重构后的员工信息类
 * 职责：只负责员工的工作相关信息
 */
@Entity
@Table(name = "employee_info")
public class EmployeeInfo {
    @Id
    private Long userProfileId; // 与UserProfile的ID一致
    
    @OneToOne
    @MapsId
    @JoinColumn(name = "user_profile_id")
    private UserProfile userProfile;
    
    private String department;
    private String position;
    private Double salary;
    
    @Temporal(TemporalType.TIMESTAMP)
    private Date hireDate;
    
    @Temporal(TemporalType.TIMESTAMP)
    private Date updateTime;
    
    public EmployeeInfo() {}
    
    public EmployeeInfo(UserProfile userProfile, String department, String position) {
        this.userProfile = userProfile;
        this.department = department;
        this.position = position;
        this.hireDate = new Date();
    }
    
    @PreUpdate
    public void preUpdate() {
        this.updateTime = new Date();
    }
    
    // Getters and Setters
    public Long getUserProfileId() { return userProfileId; }
    public void setUserProfileId(Long userProfileId) { this.userProfileId = userProfileId; }
    
    public UserProfile getUserProfile() { return userProfile; }
    public void setUserProfile(UserProfile userProfile) { this.userProfile = userProfile; }
    
    public String getDepartment() { return department; }
    public void setDepartment(String department) { this.department = department; }
    
    public String getPosition() { return position; }
    public void setPosition(String position) { this.position = position; }
    
    public Double getSalary() { return salary; }
    public void setSalary(Double salary) { this.salary = salary; }
    
    public Date getHireDate() { return hireDate; }
    public void setHireDate(Date hireDate) { this.hireDate = hireDate; }
    
    public Date getUpdateTime() { return updateTime; }
    public void setUpdateTime(Date updateTime) { this.updateTime = updateTime; }
}