package com.example.refactor.repository.v2;

import com.example.refactor.entity.v2.EmployeeInfo;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

import java.util.List;

@Repository
public interface EmployeeInfoRepository extends JpaRepository<EmployeeInfo, Long> {
    
    List<EmployeeInfo> findByDepartment(String department);
    
    List<EmployeeInfo> findByPosition(String position);
    
    @Query("SELECT ei FROM EmployeeInfo ei WHERE ei.salary BETWEEN ?1 AND ?2")
    List<EmployeeInfo> findBySalaryRange(Double minSalary, Double maxSalary);
    
    @Query("SELECT SUM(ei.salary) FROM EmployeeInfo ei WHERE ei.department = ?1")
    Double getTotalSalaryByDepartment(String department);
}