package com.example.refactor.repository.v2;

import com.example.refactor.entity.v2.UserProfile;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Optional;

@Repository
public interface UserProfileRepository extends JpaRepository<UserProfile, Long> {
    
    Optional<UserProfile> findByEmail(String email);
    
    @Query("SELECT up FROM UserProfile up WHERE up.name LIKE %?1%")
    List<UserProfile> findByNameContaining(String name);
    
    List<UserProfile> findByPhoneContaining(String phone);
}