package com.example.refactor.repository.v2;

import com.example.refactor.entity.v2.UserSecurity;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;
import org.springframework.stereotype.Repository;

import java.util.Date;
import java.util.List;

@Repository
public interface UserSecurityRepository extends JpaRepository<UserSecurity, Long> {
    
    List<UserSecurity> findByStatus(UserSecurity.UserStatus status);
    
    @Query("SELECT us FROM UserSecurity us WHERE us.lastLoginTime > ?1")
    List<UserSecurity> findRecentlyLoggedIn(Date since);
    
    @Query("SELECT us FROM UserSecurity us WHERE us.failedLoginAttempts >= ?1")
    List<UserSecurity> findByFailedLoginAttemptsGreaterThanEqual(Integer attempts);
    
    @Query("SELECT us FROM UserSecurity us WHERE us.status = 'LOCKED' AND us.lockedUntil < CURRENT_TIMESTAMP")
    List<UserSecurity> findExpiredLocks();
}